StoredSortedEntrySet (Oracle - Berkeley DB Java Edition API)
Date: 2014-12-16

com.sleepycat.collections

## Class StoredSortedEntrySet<K,V>

- java.lang.Object
- - com.sleepycat.collections.StoredContainer
  - - com.sleepycat.collections.StoredCollection<Map.Entry<K,V>>
    - - com.sleepycat.collections.StoredEntrySet<K,V>
      - - com.sleepycat.collections.StoredSortedEntrySet<K,V>

- All Implemented Interfaces:
    Cloneable, Iterable<Map.Entry<K,V>>, Collection<Map.Entry<K,V>>, Set<Map.Entry<K,V>>, SortedSet<Map.Entry<K,V>>

      public class StoredSortedEntrySet<K,V>
      extends StoredEntrySet<K,V>
      implements SortedSet<Map.Entry<K,V>>

  The SortedSet returned by Map.entrySet(). This class may not be instantiated directly. Contrary to what is stated by `Map.entrySet()` this class does support the `StoredEntrySet.add(java.util.Map.Entry<K, V>)` and `StoredCollection.addAll(java.util.Collection<? extends E>)` methods.

  The `Map.Entry.setValue(V)` method of the Map.Entry objects that are returned by this class and its iterators behaves just as the `StoredIterator.set(E)` method does.

  In addition to the standard SortedSet methods, this class provides the following methods for stored sorted sets only. Note that the use of these methods is not compatible with the standard Java collections interface.

  - `headSet(Map.Entry, boolean)`
  - `tailSet(Map.Entry, boolean)`
  - `subSet(Map.Entry, boolean, Map.Entry, boolean)`
  Author:
    Mark Hayes

- - ### Field Summary

    - ### Fields inherited from class com.sleepycat.collections.StoredCollection

      `DEFAULT_ITERATOR_BLOCK_SIZE`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Comparator<? super Map.Entry<K,V>>` | `comparator()` Returns null since comparators are not supported.
    `Map.Entry<K,V>` | `first()` Returns the first (lowest) element currently in this sorted set.
    `SortedSet<Map.Entry<K,V>>` | `headSet(Map.Entry<K,V> toMapEntry)` Returns a view of the portion of this sorted set whose elements are strictly less than toMapEntry.
    `SortedSet<Map.Entry<K,V>>` | `headSet(Map.Entry<K,V> toMapEntry, boolean toInclusive)` Returns a view of the portion of this sorted set whose elements are strictly less than toMapEntry, optionally including toMapEntry.
    `Map.Entry<K,V>` | `last()` Returns the last (highest) element currently in this sorted set.
    `SortedSet<Map.Entry<K,V>>` | `subSet(Map.Entry<K,V> fromMapEntry, boolean fromInclusive, Map.Entry<K,V> toMapEntry, boolean toInclusive)` Returns a view of the portion of this sorted set whose elements are strictly greater than fromMapEntry and strictly less than toMapEntry, optionally including fromMapEntry and toMapEntry.
    `SortedSet<Map.Entry<K,V>>` | `subSet(Map.Entry<K,V> fromMapEntry, Map.Entry<K,V> toMapEntry)` Returns a view of the portion of this sorted set whose elements range from fromMapEntry, inclusive, to toMapEntry, exclusive.
    `SortedSet<Map.Entry<K,V>>` | `tailSet(Map.Entry<K,V> fromMapEntry)` Returns a view of the portion of this sorted set whose elements are greater than or equal to fromMapEntry.
    `SortedSet<Map.Entry<K,V>>` | `tailSet(Map.Entry<K,V> fromMapEntry, boolean fromInclusive)` Returns a view of the portion of this sorted set whose elements are strictly greater than fromMapEntry, optionally including fromMapEntry.

    - ### Methods inherited from class com.sleepycat.collections.StoredEntrySet

      `add, contains, remove, toString`

    - ### Methods inherited from class com.sleepycat.collections.StoredCollection

      `addAll, containsAll, equals, getIteratorBlockSize, hashCode, iterator, iterator, join, removeAll, retainAll, setIteratorBlockSize, size, storedIterator, storedIterator, toArray, toArray, toList`

    - ### Methods inherited from class com.sleepycat.collections.StoredContainer

      `areDuplicatesAllowed, areDuplicatesOrdered, areKeyRangesAllowed, areKeysRenumbered, clear, getCursorConfig, isEmpty, isOrdered, isSecondary, isTransactional, isWriteAllowed`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Set

      `add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray`

- - ### Method Detail

    - #### comparator

          public Comparator<? super Map.Entry<K,V>> comparator()

      Returns null since comparators are not supported. The natural ordering of a stored collection is data byte order, whether the data classes implement the `Comparable` interface or not. This method does not conform to the `SortedSet.comparator()` interface.
      Specified by:
        `comparator` in interface `SortedSet<Map.Entry<K,V>>`
      Returns:
        null.

    - #### first

          public Map.Entry<K,V> first()

      Returns the first (lowest) element currently in this sorted set. This method conforms to the `SortedSet.first()` interface.
      Specified by:
        `first` in interface `SortedSet<Map.Entry<K,V>>`
      Returns:
        the first element.
      Throws:
        `OperationFailureException` - if one of the Read Operation Failures occurs.
        `EnvironmentFailureException` - if an unexpected, internal or environment-wide failure occurs.
        `RuntimeExceptionWrapper` - if a checked exception is thrown, including a `DatabaseException` on BDB (C edition).

    - #### last

          public Map.Entry<K,V> last()

      Returns the last (highest) element currently in this sorted set. This method conforms to the `SortedSet.last()` interface.
      Specified by:
        `last` in interface `SortedSet<Map.Entry<K,V>>`
      Returns:
        the last element.
      Throws:
        `OperationFailureException` - if one of the Read Operation Failures occurs.
        `EnvironmentFailureException` - if an unexpected, internal or environment-wide failure occurs.
        `RuntimeExceptionWrapper` - if a checked exception is thrown, including a `DatabaseException` on BDB (C edition).

    - #### headSet

          public SortedSet<Map.Entry<K,V>> headSet(Map.Entry<K,V> toMapEntry)

      Returns a view of the portion of this sorted set whose elements are strictly less than toMapEntry. This method conforms to the `SortedSet.headSet(E)` interface.

      Note that the return value is a StoredCollection and must be treated as such; for example, its iterators must be explicitly closed.

      Specified by:
        `headSet` in interface `SortedSet<Map.Entry<K,V>>`
      Parameters:
        `toMapEntry` - the upper bound.
      Returns:
        the subset.
      Throws:
        `RuntimeExceptionWrapper` - if a checked exception is thrown, including a `DatabaseException` on BDB (C edition).

    - #### headSet

          public SortedSet<Map.Entry<K,V>> headSet(Map.Entry<K,V> toMapEntry,
                                          boolean toInclusive)

      Returns a view of the portion of this sorted set whose elements are strictly less than toMapEntry, optionally including toMapEntry. This method does not exist in the standard `SortedSet` interface.

      Note that the return value is a StoredCollection and must be treated as such; for example, its iterators must be explicitly closed.

      Parameters:
        `toMapEntry` - is the upper bound.
        `toInclusive` - is true to include toMapEntry.
      Returns:
        the subset.
      Throws:
        `RuntimeExceptionWrapper` - if a checked exception is thrown, including a `DatabaseException` on BDB (C edition).

    - #### tailSet

          public SortedSet<Map.Entry<K,V>> tailSet(Map.Entry<K,V> fromMapEntry)

      Returns a view of the portion of this sorted set whose elements are greater than or equal to fromMapEntry. This method conforms to the `SortedSet.tailSet(E)` interface.

      Note that the return value is a StoredCollection and must be treated as such; for example, its iterators must be explicitly closed.

      Specified by:
        `tailSet` in interface `SortedSet<Map.Entry<K,V>>`
      Parameters:
        `fromMapEntry` - is the lower bound.
      Returns:
        the subset.
      Throws:
        `RuntimeExceptionWrapper` - if a checked exception is thrown, including a `DatabaseException` on BDB (C edition).

    - #### tailSet

          public SortedSet<Map.Entry<K,V>> tailSet(Map.Entry<K,V> fromMapEntry,
                                          boolean fromInclusive)

      Returns a view of the portion of this sorted set whose elements are strictly greater than fromMapEntry, optionally including fromMapEntry. This method does not exist in the standard `SortedSet` interface.

      Note that the return value is a StoredCollection and must be treated as such; for example, its iterators must be explicitly closed.

      Parameters:
        `fromMapEntry` - is the lower bound.
        `fromInclusive` - is true to include fromMapEntry.
      Returns:
        the subset.
      Throws:
        `RuntimeExceptionWrapper` - if a checked exception is thrown, including a `DatabaseException` on BDB (C edition).

    - #### subSet

          public SortedSet<Map.Entry<K,V>> subSet(Map.Entry<K,V> fromMapEntry,
                                         Map.Entry<K,V> toMapEntry)

      Returns a view of the portion of this sorted set whose elements range from fromMapEntry, inclusive, to toMapEntry, exclusive. This method conforms to the `SortedSet.subSet(E, E)` interface.

      Note that the return value is a StoredCollection and must be treated as such; for example, its iterators must be explicitly closed.

      Specified by:
        `subSet` in interface `SortedSet<Map.Entry<K,V>>`
      Parameters:
        `fromMapEntry` - is the lower bound.
        `toMapEntry` - is the upper bound.
      Returns:
        the subset.
      Throws:
        `RuntimeExceptionWrapper` - if a checked exception is thrown, including a `DatabaseException` on BDB (C edition).

    - #### subSet

          public SortedSet<Map.Entry<K,V>> subSet(Map.Entry<K,V> fromMapEntry,
                                         boolean fromInclusive,
                                         Map.Entry<K,V> toMapEntry,
                                         boolean toInclusive)

      Returns a view of the portion of this sorted set whose elements are strictly greater than fromMapEntry and strictly less than toMapEntry, optionally including fromMapEntry and toMapEntry. This method does not exist in the standard `SortedSet` interface.

      Note that the return value is a StoredCollection and must be treated as such; for example, its iterators must be explicitly closed.

      Parameters:
        `fromMapEntry` - is the lower bound.
        `fromInclusive` - is true to include fromMapEntry.
        `toMapEntry` - is the upper bound.
        `toInclusive` - is true to include toMapEntry.
      Returns:
        the subset.
      Throws:
        `RuntimeExceptionWrapper` - if a checked exception is thrown, including a `DatabaseException` on BDB (C edition).

Copyright (c) 2004, 2014 Oracle and/or its affiliates. All rights reserved.